// Copyright (C) 2005 Ramachandra <ramachandra@gmail.com>
// All rights reserved.

package yab.io;

import java.io.*;
import java.net.*;

public class TCPSocket implements ProtocolConstants {
    private InetAddress m_address;
    private int m_port;
    private Socket m_socket;
    private short m_sendingId = 0;
	private DataInputStream inStream;

    public TCPSocket(InetAddress kernelAddress, int kernelPort) {
        try {
            m_address = kernelAddress;
            m_port    = kernelPort;
            m_socket  = new Socket(m_address, m_port);
        } catch (Exception e) { throw new Error(e); }
    }

    public byte[] receive() 
	{
		
		byte[] buf = new byte[4];
		byte[] message;
		
		try{
		
			DataInputStream inStream = new DataInputStream(m_socket.getInputStream());
			int received;
			int total = 0;
		
	/*	while(total < 4)
		{
			received = inStream.read(buf);
			if(received < 0)
			{
				System.out.println("TCP Kshitij: Less than four");
				return message;
			}
			total += received;
		}*/
		
			int length = inStream.readInt();
		//	int length = (buf[0] << 24) + (buf[1]<<16) + (buf[2]<<8) + (buf[3]);
			total = 0;
			message = new byte[length];
		//	byte[] tempbuf = new byte[length]
			inStream.readFully(message);
			return message;
        } catch (Exception e) { throw new Error(e); }
	}
		
			
    public void send(byte[] data) 
	{
		final int length = data.length;
		
		try{
			DataOutputStream outStream = new DataOutputStream(m_socket.getOutputStream());
			outStream.writeInt(length);
			outStream.write(data,0,length);
			return;
		} catch (Exception e) { throw new Error(e); }
	}

}

